---
# Don't forget to keep this file updated
# molecule/<scenario>/verify.yml
- name: "Verify:role-install-docker"
  hosts: "cicd-ubuntu-24:&role-install-docker"
  gather_facts: true
  tasks:

    - name: "Get Docker service current state"
      register: "install_docker__service_status"
      failed_when: "not install_docker__service_status.status.ActiveState == 'active'"
      ansible.builtin.systemd:
        name: "docker"

    - name: "Check docker-compose command response"
      register: "output"
      changed_when: "output.rc != 0"
      failed_when: "output.rc != 0"
      ansible.builtin.command: "docker -v"

    - name: "Check docker-compose command response"
      register: "output"
      changed_when: "output.rc != 0"
      failed_when: "output.rc != 0"
      ansible.builtin.command: "docker-compose -v"


- name: "Verify:role-install-docker-swarm"
  hosts: "cicd-ubuntu-24:&role-install-docker-swarm"
  gather_facts: true
  tasks:

    - name: "Check the state of nodes in the cluster on Manager"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'Leader' not in docker_command_result.stdout"
      ansible.builtin.shell: |
        docker node ls

    - name: "Check the state of nodes in the cluster on Worker"
      when: "not inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'This node is not a swarm manager' not in docker_command_result.stderr_lines[0]"
      ansible.builtin.shell: |
        docker node ls

    - name: "Check the state of services in the Portainer stack on Manager"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "'portainer' not in docker_command_result.stdout"
      ansible.builtin.shell: |
        docker service ls --filter label=com.docker.stack.namespace=portainer

    - name: "Filter nodes by role (Manager)"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "docker_command_result.stdout == ''"
      ansible.builtin.shell: |
        docker node ls --filter role=manager

    - name: "Filter nodes by role (Workers)"
      when: "inv__install_docker_swarm_is_manager | default(false)"
      register: "docker_command_result"
      failed_when: "docker_command_result.stdout == ''"
      ansible.builtin.shell: |
        docker node ls --filter role=worker
